'--------------------------------------------------------------------------
'  DeMo-Fileforum.vbs Script
'
' This script is designed to grab software releases from Fileforum.com
'
' You may retrieve Daily releases; Weekly Top 3, Top 5 and Top 10 apps.
' And also the file of the week.
'
' This is version 1.0
' Contact me @ http://www.samurize.com/modules/ipboard/index.php?showuser=230
'
'--------------------------------------------------------------------------


'----------------- CONFIGURATION -----------------
Const FILEFORUM_ADDR = "http://fileforum.betanews.com/" 'Neowin website address
Const SHOW_RELEASE_DATE = "1"                           '0 means disabled, 1 means enabled
Const TOTAL_RELEASES = "5"                              'N of releases you want to retrieve (MAX: 30)
Const SHOW_TOP_POSITION = "1"				'0 means disabled, 1 means enabled
'----------------- CONFIGURATION -----------------



'----------------- DO NOT CHANGE ANYTHING BELOW THIS LINE!!! -----------------

Function GetReleases()
    GetReleases = getNews("all", 0)
End Function

Function GetFileOfTheWeek()
    GetFileOfTheWeek = getNews("fotw", 0)
End Function

Function GetTop1()
    GetTop1 = getNews("top", 1)
End Function

Function GetTop3()
    GetTop3 = getNews("top", 3)
End Function

Function GetTop5()
    GetTop5 = getNews("top", 5)
End Function

Function GetTop10()
    GetTop10 = getNews("top", 10)
End Function


Function getNews(Section, TopNumber)


    Dim htmlResult
    Dim strTitle(29), strDate(29), strTitleOK(29), strDateOK(29)

    Set RE = New RegExp
    RE.Global = True


    If Section = "all" Then
      htmlResult = ReturnHTML(FILEFORUM_ADDR)
      WorkingResult = HTMLSpecialCharacters_(htmlResult)

      'Get titles
      RE.Pattern = "<b>(.*?)</b></a></font><font"
      Set titletemp = RE.Execute(WorkingResult)

      For i = 0 To 29
        Set oMatch = titletemp(i)
        strTitle(i) = oMatch.SubMatches(0)
      Next

      'Get dates
      RE.Pattern = "<i>(.*?)</i></font>"
      Set datestemp = RE.Execute(WorkingResult)

      For i = 0 To 29
        Set oMatch = datestemp(i)
        strDate(i) = oMatch.SubMatches(0)
      Next

      'Correct list order and output
      'First item
      strTitleOK(0) = strTitle(0)
      strDateOK(0) = strDate(0)
      
      For i = 1 To 14
        strTitleOK(i) = strTitle(i * 2)
        strDateOK(i) = strDate(i * 2)
      Next
      
      For i = 15 To 29
        strTitleOK(i) = strTitle(i - (29 - i))
        strDateOK(i) = strDate(i - (29 - i))
      Next

      
      For b = 0 To (TOTAL_RELEASES - 1)
        If SHOW_RELEASE_DATE = "1" Then
          getNews = getNews & strTitleOK(b) & " (" & strDateOK(b) & ")" & vbCrLf
        Else
          getNews = getNews & strTitleOK(b) & vbCrLf
        End If
      Next

    ElseIf Section = "fotw" Then
      htmlResult = ReturnHTML(FILEFORUM_ADDR)
      WorkingResult = HTMLSpecialCharacters_(htmlResult)

      RE.Pattern = "<b><u>(.*?)</u></b>"
      Set titletemp = RE.Execute(WorkingResult)
      Set oMatch = titletemp(0)
      strTitle(0) = oMatch.SubMatches(0)

      getNews = strTitle(0)

    ElseIf Section = "top" Then
      htmlResult = ReturnHTML(FILEFORUM_ADDR)
      WorkingResult = HTMLSpecialCharacters_(htmlResult)

      RE.Pattern = ">(.*?)</a></b></font><br>"
      Set titletemp = RE.Execute(WorkingResult)

      For i = 0 To TopNumber - 1
        Set oMatch = titletemp(i)
        strTitle(i) = oMatch.SubMatches(0)
      Next

      For b = 0 To TopNumber - 1
        If SHOW_TOP_POSITION = "1" Then
          getNews = getNews & CStr(b + 1) & "- " & strTitle(b) & vbCrLf
        Else
          getNews = getNews & strTitle(b) & vbCrLf
        End If
      Next

    End If

    Set RE = Nothing
    Set oMatch = Nothing
    Set titletemp = Nothing
    Set datestemp = Nothing

End Function

Function ReturnHTML(sURL)
    Randomize
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function


'Thanks to AdamC for these functions below!!

Function HTMLSpecialCharacters_(varText)
    varText = ChangeHTMLCharacters_(varText, "&nbsp;", " ")
    varText = ChangeHTMLCharacters_(varText, "&quot;", """")
    varText = ChangeHTMLCharacters_(varText, "&amp;", "&")
    varText = ChangeHTMLCharacters_(varText, "&lt;", "<")
    varText = ChangeHTMLCharacters_(varText, "&gt;", ">")
    varText = ChangeHTMLCharacters_(varText, "&copy;", "")
    varText = ChangeHTMLCharacters_(varText, "&trade;", "")
    varText = ChangeHTMLCharacters_(varText, "&#33;", "!")
    varText = ChangeHTMLCharacters_(varText, "&#34;", """")
    varText = ChangeHTMLCharacters_(varText, "&#35;", "#")
    varText = ChangeHTMLCharacters_(varText, "&#36;", "$")
    varText = ChangeHTMLCharacters_(varText, "&#37;", "%")
    varText = ChangeHTMLCharacters_(varText, "&#38;", "&")
    varText = ChangeHTMLCharacters_(varText, "&#39;", "'")
    varText = ChangeHTMLCharacters_(varText, "&#40;", "(")
    varText = ChangeHTMLCharacters_(varText, "&#41;", ")")
    varText = ChangeHTMLCharacters_(varText, "&#42;", "*")
    varText = ChangeHTMLCharacters_(varText, "&#43;", "+")
    varText = ChangeHTMLCharacters_(varText, "&#44;", ",")
    varText = ChangeHTMLCharacters_(varText, "&#45;", "-")
    varText = ChangeHTMLCharacters_(varText, "&#46;", ".")
    varText = ChangeHTMLCharacters_(varText, "&#47;", "/")
    varText = ChangeHTMLCharacters_(varText, "&#58;", ";")
    varText = ChangeHTMLCharacters_(varText, "&#59;", ";")
    varText = ChangeHTMLCharacters_(varText, "&#60;", "<")
    varText = ChangeHTMLCharacters_(varText, "&#61;", "=")
    varText = ChangeHTMLCharacters_(varText, "&#62;", ">")
    varText = ChangeHTMLCharacters_(varText, "&#63;", "?")
    varText = ChangeHTMLCharacters_(varText, "&#64;", "@")
    varText = ChangeHTMLCharacters_(varText, "&#91;", "[")
    varText = ChangeHTMLCharacters_(varText, "&#92;", "\")
    varText = ChangeHTMLCharacters_(varText, "&#93;", "]")
    varText = ChangeHTMLCharacters_(varText, "&#94;", "^")
    varText = ChangeHTMLCharacters_(varText, "&#95;", "_")
    varText = ChangeHTMLCharacters_(varText, "&#96;", "`")
    varText = ChangeHTMLCharacters_(varText, "&#123;", "{")
    varText = ChangeHTMLCharacters_(varText, "&#124;", "|")
    varText = ChangeHTMLCharacters_(varText, "&#125;", "}")
    varText = ChangeHTMLCharacters_(varText, "&#126;", "~")
    varText = ChangeHTMLCharacters_(varText, "&#169;", "")
    varText = ChangeHTMLCharacters_(varText, "&#174;", "")

    HTMLSpecialCharacters_ = varText
End Function


Function ChangeHTMLCharacters_(varText, varString, varReplaceWith)
    While InStr(varText, varString) > 0
        varText = Replace(varText, varString, varReplaceWith)
    Wend
    ChangeHTMLCharacters_ = varText
End Function